// <- ovde idu include-ovi implementiranih klasa
#include "tst.h"
#include <iostream>
using namespace std;

// forward declare tested types
class Message;
class TransmissionLine;
class OverloadException;
class LineEmptyException;
class Cipher;
class RowTranspositionCipher;
class RailFenceCipher;
class ProtectedTransmissionLine;

int main(int argc, char const* argv[]) {
	using namespace std;
	int pts = 0;

	pts += Test1::tst<Message>();
	pts += Test2::tst<Message>();
	pts += Test3::tst<Message>();
	pts += Test4::tst<Message>();

	pts += Test5::tst<Message, TransmissionLine>();
	pts += Test6::tst<Message, TransmissionLine>();
	pts += Test7::tst<Message, TransmissionLine, OverloadException>();
	pts += Test8::tst<Message, TransmissionLine, LineEmptyException>();

	pts += Test9::tst<Cipher, RowTranspositionCipher>();
	pts += Test10::tst<Cipher, RowTranspositionCipher>();
	pts += Test11::tst<Cipher, RailFenceCipher>();
	pts += Test12::tst<Cipher, RailFenceCipher>();

	pts += Test13::tst<Message, TransmissionLine, Cipher, RowTranspositionCipher, RailFenceCipher, ProtectedTransmissionLine>();
	pts += Test14::tst<Message, TransmissionLine, Cipher, RowTranspositionCipher, RailFenceCipher, ProtectedTransmissionLine>();
	
	std::cout << "Points: " << pts << std::endl;

	return 0;
}
